class ExtendableError extends Error {
  constructor (msg) {
    super(msg)
    this.name = this.constructor.name
    this.message = msg
    if (typeof Error.captureStackTrace === 'function') {
      Error.captureStackTrace(this, this.constructor)
    } else {
      this.stack = (new Error(msg)).stack
    }
  }
}

exports.SchemaError = class SchemaError extends ExtendableError {
  constructor (msg) {
    super(msg || 'Schema error')
    this.schemaError = true
  }
}

exports.ParameterError = class ParameterError extends ExtendableError {
  constructor (msg) {
    super(msg || 'Invalid parameter')
    this.parameterError = true
  }
}

exports.QueryError = class QueryError extends ExtendableError {
  constructor (msg) {
    super(msg || 'Query is malformed')
    this.queryError = true
  }
}
